<template>
    <v-container>
        <v-row>
            <v-col>
                <div class="field-label">{{ $t('tag') }}</div>
                <v-text-field
                    v-model="tag"
                    hide-details
                    autofocus
                    outlined
                    @input="onInput"
                ></v-text-field>
            </v-col>
        </v-row>
        <v-row>
            <v-col>
                <div class="field-label">{{ $t('scanned') }}</div>
                <v-list outlined rounded min-height="60">
                    <v-list-item
                        v-for="(item, index) in scanned"
                        :key="index"
                    >
                        <template v-if="returnObject">
                            <v-list-item-content>
                                <v-chip
                                    class="chip-block d-flex flex-grow-1"
                                    tag="div"
                                    color="primary"
                                    label
                                    close
                                    :disabled="loading"
                                    @click:close="removeScanned(item)"
                                >
                                    <v-icon>mdi-tag</v-icon>
                                    <span class="px-2">{{ item.tag }}</span>
                                    <v-spacer></v-spacer>
                                    <v-icon small>mdi-circle-close</v-icon>
                                </v-chip>
                            </v-list-item-content>
                            <v-list-item-content class="pl-2">
                                <v-select
                                    v-model="item.status"
                                    item-value="id"
                                    item-text="name"
                                    :items="statuses"
                                    dense
                                    outlined
                                    hide-details
                                    :menu-props="{ bottom: true, offsetY: true }"
                                >
                                    <template slot="selection" slot-scope="data">
                                        {{ $t(data.item.name) }}
                                    </template>
                                    <template slot="item" slot-scope="data">
                                        {{ $t(data.item.name) }}
                                    </template>
                                </v-select>
                            </v-list-item-content>
                        </template>

                        <template v-else>
                            <v-chip
                                class="chip-block d-flex flex-grow-1"
                                tag="div"
                                color="primary"
                                label
                                close
                                :disabled="loading"
                                @click:close="removeScanned(item)"
                            >
                                <v-icon>mdi-tag</v-icon>
                                <span class="px-2">{{ item }}</span>
                                <v-spacer></v-spacer>
                                <v-icon small>mdi-circle-close</v-icon>
                            </v-chip>
                        </template>
                    </v-list-item>
                </v-list>
                <div
                    v-if="error"
                    class="pa-2 v-messages error--text"
                >
                    {{ error }}
                </div>
            </v-col>
        </v-row>
        <v-row align="center" justify="center" dense>
            <v-col cols="2">
                <v-btn
                    :loading="loading"
                    @click="onConfirm"
                    color="primary"
                >
                    {{ $t('confirm') }}
                </v-btn>
            </v-col>
        </v-row>
    </v-container>
</template>

<script>
    import StockStatus from '../../../constants/stock'

    export default {
        name: 'ScanTag',
        props: {
            statuses: {
                type: Array,
                default: () => []
            },
            returnObject: {
                type: Boolean,
                default: false
            },
            loading: {
                type: Boolean,
                default: false
            }
        },
        data: () => ({
            tag: null,
            scanned: [],
            error: ''
        }),
        methods: {
            onInput: _.debounce(function (val) {
                if(this.returnObject) {
                    this.scanned.push({
                        tag: val,
                        status: StockStatus.IN_STOCK
                    })
                }
                else {
                    this.scanned.push(val)
                }
                this.tag = ''
            }, 500),

            removeScanned(item) {
                let key = item instanceof Object ? item.tag : item

                const index = this.scanned.findIndex(s => s === key)
                this.scanned.splice(index, 1)
            },

            onConfirm() {
                if(!!this.scanned.length) {
                    this.error = ''
                    this.$emit('confirmed', this.scanned);
                }
                else {
                    this.error = this.$t('validation.required', { _field_: this.$t('tag') })
                }
            }
        }
    }
</script>

<style scoped>
    .chip-block >>> .v-chip__content {
        display: flex;
        width: 100%;
    }
</style>
